var curUserId = null;
var curChatUserId = "";
var conn = null;
var curRoomId = null;
var curChatRoomId = null;
var msgCardDivId = "chat01";
var talkToDivId = "talkTo";
var talkInputId = "talkInputId";
var bothRoster = [];
var toRoster = [];
var maxWidth = 200;
var groupFlagMark = "groupchat";
var chatRoomMark = "chatroom";
var groupQuering = false;
var textSending = false;
var time = 0;
var flashFilename = '';
var audioDom = [];
var picshim;
var audioshim;
var fileshim;
var PAGELIMIT = 8;
var pageLimitKey = new Date().getTime();
var curImage = "";
var curName = "";
var userImage = "";
var userName = "";
var encode = function(str) {
	if (!str || str.length === 0)
		return "";
	var s = '';
	s = str.replace(/&amp;/g, "&");
	s = s.replace(/<(?=[^o][^)])/g, "&lt;");
	s = s.replace(/>/g, "&gt;");
	// s = s.replace(/\'/g, "&#39;");
	s = s.replace(/\"/g, "&quot;");
	s = s.replace(/\n/g, "<br>");
	return s;
};
window.URL = window.URL || window.webkitURL || window.mozURL || window.msURL;
conn = new Easemob.im.Connection({
	multiResources : Easemob.im.config.multiResources,
	https : Easemob.im.config.https,
	url : Easemob.im.config.xmppURL
});
// 初始化连接
conn.listen({
	// 当连接成功时的回调方法
	onOpened : function() {
		handleOpen(conn);
	},
	// 当连接关闭时的回调方法
	onClosed : function() {
		handleClosed();
	},
	// 收到文本消息时的回调方法
	onTextMessage : function(message) {
		handleTextMessage(message);
	},
	// 收到表情消息时的回调方法
	onEmotionMessage : function(message) {
		handleEmotion(message);
	},
	// 收到图片消息时的回调方法
	onPictureMessage : function(message) {
		handlePictureMessage(message);
	},
	// 收到音频消息的回调方法
	onAudioMessage : function(message) {
		handleAudioMessage(message);
	},
	// 收到文件消息的回调方法
	onFileMessage : function(message) {
		handleFileMessage(message);
	},
	// 收到视频消息的回调方法
	onVideoMessage : function(message) {
		handleVideoMessage(message);
	},
	// 收到联系人订阅请求的回调方法
	onPresence : function(message) {
		handlePresence(message);
	},
	// 异常时的回调方法
	onError : function(message) {
		handleError(message);
	}
});
//表情消息回调
var handleEmotion = function(message) {
    var from = message.from.toUpperCase();
    var to = message.to.toUpperCase();
    var mestype = message.type;//消息发送的类型是群组消息还是个人消息
    var messageContent = message.data;// 文本消息体
    appendMsg(to,from,message,2);
};
//语音消息回调
var handleAudioMessage = function(message) {
    var from = message.from.toUpperCase();
    var to = message.to.toUpperCase();
    var mestype = message.type;//消息发送的类型是群组消息还是个人消息
    var messageContent = message.data;// 文本消息体
    appendMsg(to,from, {data:[{type : 'audio',filename : message.filename || '',data:[],ext:message.ext}]}, 1);
};
//图片消息回调
var handlePictureMessage = function(message) {
    var from = message.from.toUpperCase();
    var to = message.to.toUpperCase();
    var mestype = message.type;//消息发送的类型是群组消息还是个人消息
    var messageContent = message.data;// 文本消息体
    appendMsg(to,from,  {data:[{type:'pic',filename:message.filename||'',data:[],ext:message.ext}]}, 3);
};

// 处理连接时函数,主要是登录成功后对页面元素做处理
var handleOpen = function(conn) {
	// 从连接中获取到当前的登录人注册帐号名
	curUserId = conn.context.userId;
	conn.setPresence();
	// 启动心跳
	if (conn.isOpened()) {
		conn.heartBeat(conn);
	}
	conn.getRoster({
		success : function(roster) {
			//buildContactDiv(roster);
		}
	});
};
// 连接中断时的处理，主要是对页面进行处理
var handleClosed = function() {
	curUserId = null;
	curChatUserId = null;
	curRoomId = null;
	curChatRoomId = null;
	bothRoster = [];
	toRoster = [];
	for (var i = 0, l = audioDom.length; i < l; i++) {
		if (audioDom[i].jPlayer)
			audioDom[i].jPlayer('destroy');
	}
	groupQuering = false;
	textSending = false;
};
// 异常情况下的处理方法
var handleError = function(e) {
	if (curUserId == null) {
		//alert(e.msg + ",请重新登录");
	} else {
		var msg = e.msg;
		if (e.type == EASEMOB_IM_CONNCTION_SERVER_CLOSE_ERROR) {
			if (msg == "" || msg == 'unknown') {
				//alert("服务器断开连接,可能是因为在别处登录");
			} else {
				//alert("服务器断开连接");
			}
		} else if (e.type === EASEMOB_IM_CONNCTION_SERVER_ERROR) {
			if (msg.toLowerCase().indexOf("user removed") != -1) {
				//alert("用户已经在管理后台删除");
			}
		} else {
			//alert(msg);
		}
	}
	conn.stopHeartBeat(conn);
};
var handleTextMessage = function(message) {
	console.log(message)
	var from = message.from.toUpperCase();// 消息的发送者
	var to=message.to.toUpperCase();
	var mestype = message.type;// 消息发送的类型是群组消息还是个人消息
	var messageContent = message.data;// 文本消息体
	appendMsg(to,from,messageContent,0);
};
var getLoacalTimeString = function getLoacalTimeString() {
	var date = new Date();
	return date.pattern("yyyy-MM-dd HH:mm:ss");
}
//显示聊天记录的统一处理方法
var appendMsg = function(who, contact, message,vtype) {
	//联系人列表收到的消息进行本地存储
	console.log(message);
	if(message!=null){
		var db = window.sqlitePlugin.openDatabase(
				{name: 'test.db', location: 'default'},
				function(){
					},
				function (error) {
				}
		);
		var msg2=message;		
		if(typeof message!='string'){
			msg2=JSON.stringify(message);
		}
		db.transaction(
				function(tx) {
		    		tx.executeSql(
		    				'INSERT INTO LIAOTIAN (ID,LAIYUAN,MUDI,NEIRONG,TYPE,SHIJIAN,READ_STATUS) VALUES (?,?,?,?,?,?,0)',
		    				[null,contact,who,msg2,vtype,new Date().pattern("yyyy-MM-dd")],
		    				function(tx,res){},
		    				function(tx,error){}
		    		);
				},
				function(error){
					//console.log("error2:"+JSON.stringify(error))
				},
				function(){
					
				/*db.close(function(){
					
				},function(error){
					console.log("error3:"+JSON.stringify(error))
				});*/
				
				}
		);
		
		$("#message_img").attr("src","images/imessage@3x.png")
	}
};
/**
 * 用户登陆
 */
function imLogin() {
	$.ajax({
		type : "get",
		url : global.API_URL + "consumer/getImLoginInfo",
		dataType : "jsonp",
		data : {
			token : getSessionStorage("TOKEN")
		},
		timeout : 10000,
		success : function(data) {
			if (data.succ) {
				var imLogin = data.data;
				var info = buildInfo(imLogin);
				curImage = info.imageurl;
				curName = info.nickname;
				// 根据用户名密码登录系统
				conn.open({
					apiUrl : Easemob.im.config.apiURL,
					user : imLogin.username.toUpperCase(),
					pwd : imLogin.password,
					// 连接时提供appkey
					appKey : Easemob.im.config.appkey
				});
			} else {
			}
		},
		error : function(XMLHttpRequest, textStatus, errorThrown) {
			showErrorMsg("请求异常");
		}
	});
}

/**
 * 编译用户信息
 * 
 * @param obj
 * @returns
 */
function buildInfo(obj) {
	var info = {
		username : "",
		nickname : "",
		imageurl : ""
	};
	info.username = obj.consumername;
	info.nickname = obj.nickname;
	var imgurl = "img/head-img.png";
	if (obj.headimage) {
		imgurl = global.IMG01_URL + obj.headimage;
	}
	info.imageurl = imgurl;
	return info;
}
$(function() {
	imLogin();
	//buildContact();
});
