var curUserId = null;
var curChatUserId = null;
var conn = null;
var curRoomId = null;
var curChatRoomId = null;
var msgCardDivId = "chat01";
var talkToDivId = "talkTo";
var talkInputId = "talkInputId";
var bothRoster = [];
var toRoster = [];
var maxWidth = 200;
var groupFlagMark = "groupchat";
var chatRoomMark = "chatroom";
var groupQuering = false;
var textSending = false;
var time = 0;
var flashFilename = '';
var audioDom = [];
var picshim;
var audioshim;
var fileshim;
var PAGELIMIT = 8;
var pageLimitKey = new Date().getTime();

var encode = function ( str ) {
	if ( !str || str.length === 0 ) return "";
	var s = '';
	s = str.replace(/&amp;/g, "&");
	s = s.replace(/<(?=[^o][^)])/g, "&lt;");
	s = s.replace(/>/g, "&gt;");
	//s = s.replace(/\'/g, "&#39;");
	s = s.replace(/\"/g, "&quot;");
	s = s.replace(/\n/g, "<br>");
	return s;
};
window.URL = window.URL || window.webkitURL || window.mozURL || window.msURL;
var hiddenLoginUI = function () {
	$('#loginmodal').modal('hide');
};
var hiddenWaitLoginedUI = function () {
	$('#waitLoginmodal').modal('hide');
};
var showChatUI = function () {
	$('#content').css({
		"display" : "block"
	});
	var login_userEle = document.getElementById("login_user").children[0];
	login_userEle.innerHTML = curUserId;
	login_userEle.setAttribute("title", curUserId);
};
	conn = new Easemob.im.Connection({
		multiResources: Easemob.im.config.multiResources,
		https : Easemob.im.config.https,
		url: Easemob.im.config.xmppURL
	});
	//初始化连接
	conn.listen({
		//当连接成功时的回调方法
		onOpened : function() {
			handleOpen(conn);
		},
		//当连接关闭时的回调方法
		onClosed : function() {
			handleClosed();
		},
		//收到文本消息时的回调方法
		onTextMessage : function(message) {
			console.log(JSON.stringify(message));
//			handleTextMessage(message);
		},
		//收到表情消息时的回调方法
		onEmotionMessage : function(message) {
			handleEmotion(message);
		},
		//收到图片消息时的回调方法
		onPictureMessage : function(message) {
			handlePictureMessage(message);
		},
		//收到音频消息的回调方法
		onAudioMessage : function(message) {
			handleAudioMessage(message);
		},
		//收到文件消息的回调方法
		onFileMessage : function(message) {
			handleFileMessage(message);
		},
		//收到视频消息的回调方法
		onVideoMessage: function(message) {
			handleVideoMessage(message);
		},
		//收到联系人订阅请求的回调方法
		onPresence: function(message) {
			handlePresence(message);
		},
		//异常时的回调方法
		onError: function(message) {
			handleError(message);
		}
	});
//处理连接时函数,主要是登录成功后对页面元素做处理
var handleOpen = function(conn) {
	//从连接中获取到当前的登录人注册帐号名
	curUserId = conn.context.userId;
	//获取当前登录人的联系人列表
//	conn.getRoster({
//		success : function(roster) {
//			// 页面处理
//			hiddenWaitLoginedUI();
//			showChatUI();
//			curChatUserId="18616702416";
//			conn.setPresence();
//		}
//	});
	hiddenWaitLoginedUI();
	showChatUI();
	curChatUserId="18616702416";
	conn.setPresence();
	//启动心跳
	if (conn.isOpened()) {
		conn.heartBeat(conn);
	}
};
//连接中断时的处理，主要是对页面进行处理
var handleClosed = function() {
	curUserId = null;
	curChatUserId = null;
	curRoomId = null;
	curChatRoomId = null;
	bothRoster = [];
	toRoster = [];
	hiddenChatUI();
	for(var i=0,l=audioDom.length;i<l;i++) {
		if(audioDom[i].jPlayer) audioDom[i].jPlayer('destroy');
	}
	clearContactUI("contactlistUL", "contracgrouplistUL",
			"momogrouplistUL", msgCardDivId);
	showLoginUI();
	groupQuering = false;
	textSending = false;
};
//异常情况下的处理方法
var handleError = function(e) {
	curChatRoomId = null;
	e && e.upload && $('#fileModal').modal('hide');
	if (curUserId == null) {
		hiddenWaitLoginedUI();
		//alert(e.msg + ",请重新登录");
		showLoginUI();
	} else {
		var msg = e.msg;
		if (e.type == EASEMOB_IM_CONNCTION_SERVER_CLOSE_ERROR) {
			if (msg == "" || msg == 'unknown' ) {
				//alert("服务器断开连接,可能是因为在别处登录");
			} else {
				//alert("服务器断开连接");
			}
		} else if (e.type === EASEMOB_IM_CONNCTION_SERVER_ERROR) {
			if (msg.toLowerCase().indexOf("user removed") != -1) {
				//alert("用户已经在管理后台删除");
			}
		} else {
			//alert(msg);
		}
	}
	conn.stopHeartBeat(conn);
};
Array.prototype.indexOf = function(val) {
	for (var i = 0; i < this.length; i++) {
		if (this[i].name == val.name)
			return i;
	}
	return -1;
};
Array.prototype.remove = function(val) {
	var index = this.indexOf(val);
	if (index > -1) {
		this.splice(index, 1);
	}
};
var sendText = function() {
	var msgInput = document.getElementById(talkInputId);
	var msg = msgInput.value;
	if (msg == null || msg.length == 0) {
		textSending = false;
		return;
	}
	var to = curChatUserId;
	var options = {
		to : to,
		msg : msg,
		type : "chat"
	};
	conn.sendTextMessage(options);
	//当前登录人发送的信息在聊天窗口中原样显示
	var msgtext = Easemob.im.Utils.parseLink(Easemob.im.Utils.parseEmotions(encode(msg)));
};
//easemobwebim-sdk收到文本消息的回调方法的实现
var handleTextMessage = function(message) {
	var from = message.from;//消息的发送者
	var mestype = message.type;//消息发送的类型是群组消息还是个人消息
	var messageContent = message.data;//文本消息体
	//TODO  根据消息体的to值去定位那个群组的聊天记录
	var room = message.to;
	if (mestype == groupFlagMark || mestype == chatRoomMark) {
		appendMsg(message.from, mestype + message.to, messageContent);
	} else {
		appendMsg(from, from, messageContent);
	}
};
/**
 * 用户登陆
 */
function imLogin() {
	$.ajax({
		type : "get",
		url : global.API_URL + "consumer/getImLoginInfo",
		dataType : "jsonp",
		data : {
			token : getSessionStorage("TOKEN")
		},
		timeout : 10000,
		success : function(data) {
			if (data.succ) {
				var imLogin = data.data;
				//根据用户名密码登录系统
				conn.open({
					apiUrl : Easemob.im.config.apiURL,
					user : imLogin.username,
					pwd : imLogin.password,
					//连接时提供appkey
					appKey : Easemob.im.config.appkey
				}); 
			} else {
			}
		},
		error : function(XMLHttpRequest, textStatus, errorThrown) {
			showErrorMsg("请求异常");
		}
	});
}
$(function(){
	imLogin();
	$('#loginmodal').modal('hide');
});

