//热更新JS
var app = {
  initialize: function() {
    this.bindEvents();
  },
  bindEvents: function() {
    document.addEventListener('deviceready', this.onDeviceReady, false);
  },
  onDeviceReady: function() {
    document.getElementById('myFetchBtn').addEventListener('click', app.checkForUpdate);
  },
  checkForUpdate: function() {
	$("#mask").show();
	$("#load").show();
    chcp.fetchUpdate(app.fetchUpdateCallback);
  },
  fetchUpdateCallback: function(error, data) {
    if (error) {
    	$("#mask").hide();
		$("#load").hide();
		showSuccessMsg("您已更新至最新版本");
      return;
    }
    //安装更新包
    chcp.installUpdate(app.installationCallback);
  },

  installationCallback: function(error) {
	  navigator.app.clearHistory();
    if (error) {
    	$("#mask").hide();
		$("#load").hide();
    	showErrorMsg("更新包安装失败");
    } else {
    	showSuccessMsg("更新完成");
    }
  }
};
app.initialize();