(function($) {
    var config = {};
    $(window).bind('load', 
    function() {
        reset()
    });
    $(window).bind('resize', 
    function() {
        reset();
        $('.works').each(function() {
            $(this).find('img').attr('width', '').attr('height', '')
        })
    });
    function reset() {
        config.w = $(window).width();
        config.h = $(window).height();
        $('#menu').height(config.h);
        config.ww = $('.website').width();
        $('.website li,.website').width(config.ww);
        config.wl = $('.website li').length;
        $('.website ul').width(config.wl * config.ww);
        $('.ct').height(config.h - 6);
        if ($('.title_d').width() - $('.title').width() > 0) {
            $('.title_d').addClass('round')
        } else {
            $('.title_d').removeClass('round')
        };
        if (document.getElementById('newwrap_t')) {
            $('#newwrap_t,#newwrap').width(config.w)
        }
        $('#myfavorites li').width(($('#myfavorites ul').width() - 10) / 2);
        $('#myfavorites li span').width(($('#myfavorites li').width() - 20) / 3)
    }
    var touchEnd;
    var dd = 0;

    
   
    $('.menu_open').bind('click', 
    function(e) {
        if ($('#container').hasClass('pull') == false) {
            if (dd == 0) {
                $('#container,#menu,#header,#us_panel').addClass('push');
                dd = 1;
                $(window).bind('touchmove', 
                function(e) {
                    e.preventDefault();
                    e.stopImmediatePropagation()
                });
                $('#us_panel').addClass('hide')
            } else {
                $('#container,#menu,#header,#us_panel').removeClass('push');
                dd = 0;
                $(window).unbind('touchmove')
            }
        }
        return false
    });
  
   
   
})(Zepto)