var curUserId = null;
var curChatUserId = getUrlParam("id");
var conn = null;
var curRoomId = null;
var curChatRoomId = null;
var msgCardDivId = "chat01";
var talkToDivId = "talkTo";
var talkInputId = "talkInputId";
var bothRoster = [];
var toRoster = [];
var maxWidth = 200;
var groupFlagMark = "groupchat";
var chatRoomMark = "chatroom";
var groupQuering = false;
var textSending = false;
var time = 0;
var flashFilename = '';
var audioDom = [];
var picshim;
var audioshim;
var fileshim;
var PAGELIMIT = 8;
var pageLimitKey = new Date().getTime();
var curImage = "";
var curName = "";
var userImage = "";
var userName = "";
var loginCount=1;
var encode = function(str) {
	if (!str || str.length === 0)
		return "";
	var s = '';
	s = str.replace(/&amp;/g, "&");
	s = s.replace(/<(?=[^o][^)])/g, "&lt;");
	s = s.replace(/>/g, "&gt;");
	// s = s.replace(/\'/g, "&#39;");
	s = s.replace(/\"/g, "&quot;");
	s = s.replace(/\n/g, "<br>");
	return s;
};
window.URL = window.URL || window.webkitURL || window.mozURL || window.msURL;
conn = new Easemob.im.Connection({
	multiResources : Easemob.im.config.multiResources,
	https : Easemob.im.config.https,
	url : Easemob.im.config.xmppURL
});
// 初始化连接
conn.listen({
	// 当连接成功时的回调方法
	onOpened : function() {
		handleOpen(conn);
	},
	// 当连接关闭时的回调方法
	onClosed : function() {
		handleClosed();
	},
	// 收到文本消息时的回调方法
	onTextMessage : function(message) {
		handleTextMessage(message);
	},
	// 收到表情消息时的回调方法
	onEmotionMessage : function(message) {
		handleEmotion(message);
	},
	// 收到图片消息时的回调方法
	onPictureMessage : function(message) {
		handlePictureMessage(message);
	},
	// 收到音频消息的回调方法
	onAudioMessage : function(message) {
		handleAudioMessage(message);
	},
	// 收到文件消息的回调方法
	onFileMessage : function(message) {
		handleFileMessage(message);
	},
	// 收到视频消息的回调方法
	onVideoMessage : function(message) {
		handleVideoMessage(message);
	},
	// 收到联系人订阅请求的回调方法
	onPresence : function(message) {
		handlePresence(message);
	},
	// 异常时的回调方法
	onError : function(message) {
		handleError(message);
	}
});
//表情消息回调
var handleEmotion = function(message) {
    var from = message.from.toUpperCase();
    var to = message.to.toUpperCase();
    var mestype = message.type;//消息发送的类型是群组消息还是个人消息
    var messageContent = message.data;// 文本消息体
    appendMsg(to,from,message,2);
};
//语音消息回调
var handleAudioMessage = function(message) {
    var from = message.from.toUpperCase();
    var to = message.to.toUpperCase();
    var mestype = message.type;//消息发送的类型是群组消息还是个人消息
    var messageContent = message.data;// 文本消息体
    appendMsg(to,from, {data:[{type : 'audio',filename : message.filename || '',data:[],ext:message.ext}]}, 1);
};
//图片消息回调
var handlePictureMessage = function(message) {
    var from = message.from.toUpperCase();
    var to = message.to.toUpperCase();
    var mestype = message.type;//消息发送的类型是群组消息还是个人消息
    var messageContent = message.data;// 文本消息体
    appendMsg(to,from,  {data:[{type:'pic',filename:message.filename||'',data:[],ext:message.ext}]}, 3);
};

// 处理连接时函数,主要是登录成功后对页面元素做处理
var handleOpen = function(conn) {
	// 从连接中获取到当前的登录人注册帐号名
	curUserId = conn.context.userId;
	conn.setPresence();
	// 启动心跳
	if (conn.isOpened()) {
		conn.heartBeat(conn);
	}
	loginCount=1;
	conn.getRoster({
		success : function(roster) {
			buildContactDiv(roster);
		}
	});
};
// 连接中断时的处理，主要是对页面进行处理
var handleClosed = function() {
	textSending = false;
	loginCount++;
	if(loginCount>10){
		navigator.notification.alert('聊天出错了，赶紧重连吧！');
		window.location.href="index.html";
	}else{
		imLogin();
	}
};
// 异常情况下的处理方法
var handleError = function(e) {
	textSending = false;
	conn.stopHeartBeat(conn);
	loginCount++;
	if(loginCount>10){
		navigator.notification.alert('聊天出错了，赶紧重连吧！');
		window.location.href="index.html";
	}else{
		imLogin();
	}
};
Array.prototype.indexOf = function(val) {
	for (var i = 0; i < this.length; i++) {
		if (this[i].name == val.name)
			return i;
	}
	return -1;
};
Array.prototype.remove = function(val) {
	var index = this.indexOf(val);
	if (index > -1) {
		this.splice(index, 1);
	}
};

var handleTextMessage = function(message) {
	var from = message.from.toUpperCase();// 消息的发送者
	var to=message.to.toUpperCase();
	var mestype = message.type;// 消息发送的类型是群组消息还是个人消息
	var messageContent = message.data;// 文本消息体
	appendMsg(to,from,messageContent,0);
};
var getLoacalTimeString = function getLoacalTimeString() {
	var date = new Date();
	return date.pattern("yyyy-MM-dd HH:mm:ss");
}
//显示聊天记录的统一处理方法
var appendMsg = function(who, contact, message,vtype) {
	//联系人列表收到的消息进行本地存储
	if(message!=null){
		var db = window.sqlitePlugin.openDatabase(
				{name: 'test.db', location: 'default'},
				function(){
					//console.log("存储列表聊天 打开数据库 成功");
					},
				function (error) {
					//console.log('存储列表聊天 打开数据库 失败:' + JSON.stringify(error));
					}
		);
		var msg2=message;		
		if(typeof message!='string'){
			msg2=JSON.stringify(message);
		}
		db.transaction(
				function(tx) {
		    		tx.executeSql(
		    				'INSERT INTO LIAOTIAN (ID,LAIYUAN,MUDI,NEIRONG,TYPE,SHIJIAN,READ_STATUS) VALUES (?,?,?,?,?,?,0)',
		    				[null,contact,who,msg2,vtype,new Date().pattern("yyyy-MM-dd")],
		    				function(tx,res){
		    					//console.log("存储列表聊天 表中插入数据 成功");
		    					},
		    				function(tx,error){
		    						//console.log("存储列表聊天 表中插入数据 失败");
		    						}
		    		);
				},
				function(error){
					//console.log("存储列表聊天 事务操作 失败");
					},
				function(){
						/*db.close(function(){
					//console.log('存储列表聊天 关闭数据库 成功');
					},function(error){
						//console.log('存储实时聊天 关闭数据库 失败');
						});*/
						}
		);				
	}
	
		if (contact && who != contact) {
			var contactLi = $("#user_" + contact);
			if(contactLi.length>0){
				var klo = contactLi.find(".klo_pou");
				if (klo && klo.length > 0) {
					var count = klo.html();
					if (count && "" != count) {
						var myNum = new Number(count);
						myNum++;
						klo.html(myNum);
					}
				} else {
					contactLi.append("<div class=\"klo_pou\">1</div>");
				}
			}else{
				var html="";
				html+="<div class=\"ps-lt\"> <a href=\"xx_xq.html?id="+contact+"&name="+contact+"\">";
				html+="<div class=\"lt-dsb2\" id=\"user_"+contact+"\"> <i class=\"xx_a\"><img src=\""+"image/head@2X.png"+"\"></i>";
				html+="<div class=\"kobc\"> <u class=\"okcl\">"+contact+"</u> <u class=\"biaoqing\" id=\"msg_"+contact+"\"></u>";
				html+="<div class=\"klo_pou\">1</div>";
				html+="<div class=\"njh\"></div></div></div></a></div>";
				$("#contactlistUL").append(html);
				
			} 
			if(vtype==2){
				var msg="";
				for(var i=0;i<message.data.length;i++){
					var ob=message.data[i];
					if(ob.type=="txt"){
						msg+="<span>"+ob.data+"</span>";
					}
					if(ob.type=="emotion"){
						msg+="<img src=\""+ob.data+"\" />";
					}
				}
				$("#msg_"+contact).html(msg);
			}
			if(vtype==0){
				$("#msg_"+contact).html(message);
			}
			if(vtype==3){
				$("#msg_"+contact).html("[图片]");
			}
			if(vtype==1){
				$("#msg_"+contact).html("[语音]");
			}
		}
};

//构造联系人列表
var buildContactDiv = function(roster) {
	var uielem = $("#contactlistUL");
	uielem.html("");
	var names="";
	for (i = 0; i < roster.length; i++) {
//		if (!(roster[i].subscription == 'both' || roster[i].subscription == 'from')) {
//			continue;
//		}
		var jid = roster[i].jid;
		var userName = jid.substring(jid.indexOf("_") + 1).split("@")[0];
		names+=userName+",";
	}
	//SQLite数据库操作
	var db = window.sqlitePlugin.openDatabase(
			{name: 'test.db', location: 'default'},
			function(){
				//读表事务
				db.transaction(
						function(tx) {
				    			tx.executeSql(
					    				'SELECT * FROM LIAOTIAN ORDER BY SHIJIAN ASC ',
					    				[],
					    				function(tx,res){
					    					//表不为空
					    					if(res!=null){
					    						var names2='';
						    					for(var x=0;x<res.rows.length;x++){
						    						//当前用户为发送方时，拼接接收方
						    						if(curUserId==res.rows.item(x).LAIYUAN){
						    							names2=res.rows.item(x).MUDI+',';
						    						}
						    						//当前用户为接收方时，拼接发送发
						    						if(curUserId==res.rows.item(x).MUDI){
						    							names2=res.rows.item(x).LAIYUAN+',';
						    						}
						    						names+=names2+",";
						    					}
					    						$.ajax({
					    							type : "get",
					    							url : global.API_URL + "consumer/getImUserList",
					    							dataType : "jsonp",
					    							data : {
					    								token : getSessionStorage("TOKEN"),
					    								names:encodeURI(names)
					    							},
					    							timeout : 10000,
					    							success : function(data) {
					    								var html=""
					    								if (data.succ) {
					    									var dataList = data.data;
					    									for(var i=0;i<dataList.length;i++){
					    										var info=buildInfo(dataList[i]);
					    										html+="<div class=\"ps-lt\"> <a href=\"xx_xq.html?id="+info.username+"&name="+info.nickname+"\">";
					    										html+="<div class=\"lt-dsb2\" id=\"user_"+info.username.toUpperCase()+"\"> <i class=\"xx_a\"><img src=\""+info.imageurl+"\"></i>";
					    										html+="<div class=\"kobc\"> <u class=\"okcl\">"+info.nickname+"</u> <u class=\"biaoqing\" id=\"msg_"+info.username.toUpperCase()+"\"></u>";
					    										html+="<div class=\"njh\"></div></div></div></a></div>";
					    									}
					    									uielem.append(html);
					    								} else {
					    								}
					    							},
					    							error : function(XMLHttpRequest, textStatus, errorThrown) {
					    								showErrorMsg("请求异常");
					    							}
					    						});
					    					}
					    					//表为空
					    					if(res==null){
					    						$.ajax({
					    							type : "get",
					    							url : global.API_URL + "consumer/getImUserList",
					    							dataType : "jsonp",
					    							data : {
					    								token : getSessionStorage("TOKEN"),
					    								names:encodeURI(names)
					    							},
					    							timeout : 10000,
					    							success : function(data) {
					    								var html=""
					    								if (data.succ) {
					    									var dataList = data.data;
					    									for(var i=0;i<dataList.length;i++){
					    										var info=buildInfo(dataList[i]);
					    										html+="<div class=\"ps-lt\"> <a href=\"xx_xq.html?id="+info.username+"&name="+info.nickname+"\">";
					    										html+="<div class=\"lt-dsb2\" id=\"user_"+info.username.toUpperCase()+"\"> <i class=\"xx_a\"><img src=\""+info.imageurl+"\"></i>";
					    										html+="<div class=\"kobc\"> <u class=\"okcl\">"+info.nickname+"</u> <u class=\"biaoqing\" id=\"msg_"+info.username.toUpperCase()+"\"></u>";
					    										html+="<div class=\"njh\"></div></div></div></a></div>";
					    									}
					    									uielem.append(html);
					    								} else {
					    								}
					    							},
					    							error : function(XMLHttpRequest, textStatus, errorThrown) {
					    								showErrorMsg("请求异常");
					    							}
					    						});
					    					}
					    				},
					    				function(tx,error){
					    				}
					    		);
						},
						function(error){
						},
						function(){
							db.close(
								function(){
								},
								function(error){
								}
							);
						}
				);
			},
			function (error) {
			}
	);
	setTimeout("buildMessage()",1000); 
};

//构造未读消息
var buildMessage = function() {
	//SQLite数据库操作
	var db = window.sqlitePlugin.openDatabase(
			{name: 'test.db', location: 'default'},
			function(){
				//读表事务
				db.transaction(
						function(tx) {
				    			tx.executeSql(
					    				'SELECT * FROM LIAOTIAN ORDER BY SHIJIAN ASC ',
					    				[],
					    				function(tx,res){
					    					//表不为空
					    					if(res!=null){
						    					for(var xx=0;xx<res.rows.length;xx++){
						    						if(curUserId==res.rows.item(xx).MUDI){
						    							if(res.rows.item(xx).TYPE==0){
						    								$("#msg_"+res.rows.item(xx).LAIYUAN.toUpperCase()).html(res.rows.item(xx).NEIRONG);
						    							}
						    							if(res.rows.item(xx).TYPE==3){
						    								$("#msg_"+res.rows.item(xx).LAIYUAN.toUpperCase()).html("[图片]");
						    							}
						    							if(res.rows.item(xx).TYPE==1){
						    								$("#msg_"+res.rows.item(xx).LAIYUAN.toUpperCase()).html("[语音]");
						    							}
						    							if(res.rows.item(xx).TYPE==2){
						    								var msg="";
						    								var message=JSON.parse(res.rows.item(xx).NEIRONG);
						    								for(var i=0;i<message.data.length;i++){
						    									var ob=message.data[i];
						    									if(ob.type=="txt"){
						    										msg+="<span>"+ob.data+"</span>";
						    									}
						    									if(ob.type=="emotion"){
						    										msg+="<img src=\""+ob.data+"\" />";
						    									}
						    								}
						    								$("#msg_"+res.rows.item(xx).LAIYUAN.toUpperCase()).html(msg);
						    							}
						    						}
						    					}
					    					}
					    				},
					    				function(tx,error){
					    				}
					    		);
				    			tx.executeSql(
					    				'SELECT COUNT(1) SHUZI,LAIYUAN FROM LIAOTIAN WHERE MUDI=? AND READ_STATUS=0  GROUP BY LAIYUAN ',
					    				[curUserId],
					    				function(tx,res){
					    					//表不为空
					    					if(res!=null){
						    					for(var j=0;j<res.rows.length;j++){
						    						var contactLi = $("#user_" + res.rows.item(j).LAIYUAN.toUpperCase());
						    						if(contactLi.length>0){
						    							var klo = contactLi.find(".klo_pou");
						    							if (klo && klo.length > 0) {
						    								var count = klo.html();
						    								if (count && "" != count) {
						    									var myNum = new Number(count);
						    									myNum++;
						    									klo.html(myNum);
						    								}
						    							} else {
						    								contactLi.append("<div class=\"klo_pou\">"+res.rows.item(j).SHUZI+"</div>");
						    							}
						    						}
						    					}
					    					}
					    				},
					    				function(tx,error){
					    				}
					    		);
						},
						function(error){
						},
						function(){
							db.close(
								function(){
								},
								function(error){
								}
							);
						}
				);
			},
			function (error) {
			}
	);
};

/**
 * 用户登陆
 */
function imLogin() {
	$.ajax({
		type : "get",
		url : global.API_URL + "consumer/getImLoginInfo",
		dataType : "jsonp",
		data : {
			token : getSessionStorage("TOKEN")
		},
		timeout : 10000,
		success : function(data) {
			if (data.succ) {
				var imLogin = data.data;
				var info = buildInfo(imLogin);
				curImage = info.imageurl;
				curName = info.nickname;
				// 根据用户名密码登录系统
				conn.open({
					apiUrl : Easemob.im.config.apiURL,
					user : imLogin.username.toUpperCase(),
					pwd : imLogin.password,
					// 连接时提供appkey
					appKey : Easemob.im.config.appkey
				});
			} else {
			}
		},
		error : function(XMLHttpRequest, textStatus, errorThrown) {
			showErrorMsg("请求异常");
		}
	});
}
/**
 * 编译联系人信息
 */
function buildContact() {
	$.ajax({
		type : "get",
		url : global.API_URL + "consumer/getImUserList",
		dataType : "jsonp",
		data : {
			names : curChatUserId
		},
		timeout : 10000,
		success : function(data) {
			var html = ""
			if (data.succ) {
				var dataList = data.data;
				for (var i = 0; i < dataList.length; i++) {
					var info = buildInfo(dataList[i]);
					userImage = info.imageurl;
					userName = info.nickname;
					$("#name").html(userName);
				}
			} else {
			}
		},
		error : function(XMLHttpRequest, textStatus, errorThrown) {
			showErrorMsg("请求异常");
		}
	});
}

/**
 * 编译用户信息
 * 
 * @param obj
 * @returns
 */
function buildInfo(obj) {
	var info = {
		username : "",
		nickname : "",
		imageurl : ""
	};
	info.username = obj.consumername;
	info.nickname = obj.nickname;
	var imgurl = "image/head@2X.png";
	if (obj.headimage) {
		imgurl = global.IMG01_URL + obj.headimage;
	}
	info.imageurl = imgurl;
	return info;
}
$(function() {
	imLogin();
	buildContact();
});
